/***************************************************************************
 *
 *   ::::_audioeditor_::::
 *   a simple multitrack audio editor
 *
 *   track
 *   header file
 *
 *   begin                : Jan 2006
 *   copyright            : (C) 2006 by Georg Holzmann
 *   email                : grh@mur.at
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

#ifndef TRACK_H__
#define TRACK_H__

#include <QObject>
#include "portaudio.h"
#include "soundfile.h"

/*!
 * \class Track
 *
 * contains the widget and the audio data
 * of one single track (mono)
 */
class Track : public QObject
{
  Q_OBJECT
  
  public:
    Track();
    virtual ~Track();
    
    /*!
     * adds the audiodata of this track to the buffer output
     * \note everything here must be threadsafe !!!
     * @param size nr. of samples to write (bufsize)
     * @param output output buffer: always stereo !!! (see AudioCtl
     *               how to write into this buffer !)
     * @return -1 if file is over, otherwise 0
     */
    inline int process(unsigned long size, float *output)
    {
      return m_soundfile->process(size, output);
    }
    
  protected:
    /*! the soundfile data */
    Soundfile *m_soundfile;
};

#endif // TRACK_H__
