/***************************************************************************
 *
 *   ::::_audioeditor_::::
 *   a simple multitrack audio editor
 *
 *   trackmanager
 *   source file
 *
 *   begin                : Jan 2006
 *   copyright            : (C) 2006 by Georg Holzmann
 *   email                : grh@mur.at
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

#include "trackmanager.h"
#include "track.h"
#include "audioctl.h"

// define static members
QList<Track *> TrackManager::m_tracklist;
QReadWriteLock TrackManager::m_track_lock;
AudioCtl *TrackManager::m_audioctl = 0;

TrackManager::TrackManager()
{
  m_audioctl = new AudioCtl;
  
  appendTrack();
  
  m_audioctl->registerTrack(trackAudioCallback);
}

TrackManager::~TrackManager()
{
  Track *track;
  
  m_track_lock.lockForRead();
  foreach (track, m_tracklist)
  {
    delete track;
  }
  m_track_lock.unlock();
  
  m_track_lock.lockForWrite();
  m_tracklist.clear();
  m_track_lock.unlock();
  
  delete m_audioctl;
}

void TrackManager::appendTrack()
{
  Track *track = new Track;
  
  m_track_lock.lockForWrite();
  m_tracklist.append(track);
  m_track_lock.unlock();
  
  // TODO: GUI stuff machen
  
}

int TrackManager::trackAudioCallback(void *inputBuffer, void *outputBuffer,
                       unsigned long framesPerBuffer,
                       PaTimestamp outTime, void *userData )
{
  float *out = (float*)outputBuffer;
  
  // add data of the individual tracks
  Track *track;
  m_track_lock.lockForRead();
  foreach (track, m_tracklist)
  {
  // TODO: checken, wenn er .1 returniert -> EOF !!!
    track->process(framesPerBuffer, out);
  }
  m_track_lock.unlock();
  
  return 0;
}
